rawset(_G, "MIMICCFG", {
	loadedFile = false,
	write = function ()
		if not MIMICCFG.loadedFile then return end
		local f = io.openlocal("client/mimic.cfg", "w")
		f:write("mimic_permanent_tails " .. MIMICCFG.cv_tails.value .. "\n")
		f:write("mimic_skinlock " .. MIMICCFG.skinlock .. "\n")
		if MIMICCFG.seenalltips then
			f:write("mimic_notips\n")
		end
		f:close()
	end,
	cv_tails = nil,
	skinlock = "-",
	seenalltips = false
})

MIMICCFG.cv_tails = CV_RegisterVar({
	name = "mimic_permanent_tails",
	defaultvalue = 0,
	flags = CV_CALL,
	PossibleValue = CV_YesNo, 
	func = function (cv)
		MIMICCFG.write()
		if cv.value then
			print("You will now always have tails when playing as Mimic.")
		else
			print("You will now only have tails when actually mimicing Tails.")
		end
	end 
})

COM_AddCommand("mimic_skinlock", function(player, skinlock)
	if skinlock then
		MIMICCFG.skinlock = skinlock
		CONS_Printf(player, "Mimic's skinlock has been set to: " + skinlock)
		MIMICCFG.write()
	else
		CONS_Printf(player, "Mimic's skinlock is currently: " + MIMICCFG.skinlock)
	end
end, COM_LOCAL)

local f = io.openlocal("client/mimic.cfg", "r")
if f then
	for line in f:lines() do
		COM_BufInsertText(consoleplayer, line)
	end
	f:close()
end
MIMICCFG.loadedFile = true

COM_AddCommand("_mimic_sync", function(player, tails, skinlock)
	player.MIMIC_PERMATAILS = (tostring(tails) == "1")
	player.MIMIC_SKINLOCK = skinlock
end)

local cooldown = 0
addHook("ThinkFrame", function ()
	if cooldown > 0 then
		cooldown = $ - 1
		return
	end
	
	if not consoleplayer then return end
	
	if consoleplayer.MIMIC_PERMATAILS ~= (MIMICCFG.cv_tails.value == 1)
	or consoleplayer.MIMIC_SKINLOCK ~= MIMICCFG.skinlock then
		COM_BufInsertText(consoleplayer, "_mimic_sync " .. MIMICCFG.cv_tails.value .. " " .. MIMICCFG.skinlock)
		cooldown = 10
	end
end)